# K3s cluster

| Name                    | Usage                                | Accessibility | Host         | DB type    | Automated backups    | Configured                          |
| --                      | --                                   | --            | --           | --         | --                   | --                                  |
| therbron.com            | Personal website                     | Public        | Socrates     | X          | Nothing to backup    | No                                  |
| Traefik                 | Reverse proxy and load balancer      | Public*       | Socrates     | X          | Git configuration    | Partial (Missing TLS)               |
| Adguard                 | DNS ad blocker and custom DNS server | Private       | Socrates     | X          | <center> ? </center> | Yes                                 |
| Owncloud Infinity Scale | File hosting webUI                   | Public        | Plato        | PostgreSQL | <center> ? </center> | No                                  |
| Home     assistant      | Home automation and monitoring       | Private       | Pythagoras-a | PostgreSQL | <center> ? </center> | No                                  |
| Vikunja                 | To-do and Kanban boards              | Public        | Pythagoras-b | X          | <center> ? </center> | No (To be integrated in Gitlab)     |
| Gitlab                  | Version control system               | Public        | Pythagoras-b | PostgreSQL | <center> ? </center> | No                                  |
| Wiki                    | Documentation manager                | Public        | Pythagoras-b | X          | <center> ? </center> | No (Migrate to VuePress and Gitlab) |
| Vaultwarden             | Password manager                     | Public        | Pythagoras-b | PostgreSQL | <center> ? </center> | No                                  |
| Jellyfin                | Media streaming                      | Public        | Archimedes   | X          | <center> ? </center> | No                                  |
| Sonarr                  | TV shows collection manager          | Private       | Plato        | SQLite**   | <center> ? </center> | No                                  |
| Radarr                  | Movie collection manager             | Private       | Plato        | SQLite**   | <center> ? </center> | No                                  |
| Jackett                 | Torrent indexer                      | Private       | Plato        | X          | <center> ? </center> | No                                  |
| Deluge                  | Torrent client                       | Private       | Plato        | X          | <center> ? </center> | No                                  |
| Minecraft               | Vanilla minecraft server for friends | Public        | Archimedes   | X          | Longhorn snapshots   | Yes                                 |

** Current implementation only support SQLite, making manual backups a necessity

## TODO
- Change host/deployment specific variables to use environment variables
- Write CI/CD pipeline to create environment loaded files
- Write CI/CD pipeline to deploy cluster
- Look into CockroachDB for redundant database
- Add TLS certificates for every http applications
- Configure IP range accessibility through Traefik (Internal vs external services)

## Notes
Add node to the list of available load balancer
`kubectl label node <node-name> svccontroller.k3s.cattle.io/enablelb=true`

Install traefik through helm
```
helm repo add traefik https://helm.traefik.io/traefik
helm repo update
helm install -f helm/traefik/values.yaml traefik traefik/traefik
```

Install longhorn
```
kubectl apply -f https://raw.githubusercontent.com/longhorn/longhorn/master/deploy/longhorn.yaml
```
